import { Component, Input } from '@angular/core';

import { ParamDefinition } from 'jalhyd';

import { NgParameter } from '../../services/ngparam';

export class FieldSet {
    title: string;
    params: NgParameter[];

    constructor() {
        this.params = [];
    }

    public addParameter(prm: ParamDefinition) {
        this.params.push(new NgParameter(prm));
    }
}

@Component({
    selector: "field-set",
    templateUrl: "./field-set.html",
    styles: [".field_set_title {\
        font-weight: bold;\
        margin: 0.3em 0 0.2em;\
        padding: 0.3em;\
        background-color: #eeeeee;\
        }"]
})
export class FieldSetComponent {
    /**
    * field set attribute
    */
    private _fieldSet: FieldSet;

    @Input()
    private set fieldSet(fs: FieldSet) {
        this._fieldSet = fs;
    }

    constructor() {
    }
}
