"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var jalhyd_1 = require("jalhyd");
var http_service_1 = require("../http/http.service");
/*
  language tag : fr-FR
  primary subcode : fr
  optional subcode : FR
 */
var Language;
(function (Language) {
    Language[Language["FRENCH"] = 0] = "FRENCH";
    Language[Language["ENGLISH"] = 1] = "ENGLISH";
})(Language = exports.Language || (exports.Language = {}));
var InternationalisationService = (function () {
    function InternationalisationService(httpService) {
        this.httpService = httpService;
    }
    Object.defineProperty(InternationalisationService.prototype, "lang", {
        get: function () {
            return this._lang;
        },
        enumerable: true,
        configurable: true
    });
    // public set lang(l: Language) {
    //     this._lang = l;
    //     this._sLang = Language[l];
    // }
    InternationalisationService.prototype.setLocale = function (tag) {
        var l = tag.substr(0, 2).toLowerCase();
        if (l === "en")
            this._lang = Language.ENGLISH;
        else if (l === "fr")
            this._lang = Language.FRENCH;
        else {
            var e = new jalhyd_1.ErrorMessage(jalhyd_1.ErrorCode.ERROR_LANG_UNSUPPORTED);
            e.extraVar["locale"] = tag;
            throw e;
        }
        // this.loadErrorMessages();
        this.httpGetErrorMessages();
    };
    Object.defineProperty(InternationalisationService.prototype, "languageCode", {
        get: function () {
            switch (this._lang) {
                case Language.ENGLISH:
                    return "en";
                case Language.FRENCH:
                    return "fr";
                default:
                    throw new jalhyd_1.ErrorMessage(jalhyd_1.ErrorCode.ERROR_LANG_UNSUPPORTED);
            }
        },
        enumerable: true,
        configurable: true
    });
    // private loadErrorMessages() {
    //     let l;
    //     switch (this.lang) {
    //         case Language.FRENCH:
    //             l = "fr";
    //             break;
    //         default:
    //             l = "en";
    //     }
    //     let s: string = fs.readFileSync("src/error_messages." + l + ".json", "utf8");
    //     this._errorMessages = JSON.parse(s);
    // }
    InternationalisationService.prototype.httpGetErrorMessages = function () {
        var is = this;
        var processData = function (s) {
            // fermeture nécessaire pour capturer la valeur de this (undefined sinon)
            is._errorMessages = JSON.parse(s);
        };
        var l;
        switch (this.lang) {
            case Language.FRENCH:
                l = "fr";
                break;
            default:
                l = "en";
        }
        var f = "error_messages." + l + ".json";
        this.httpService.httpGetRequest(undefined, undefined, undefined, "locale/" + f, processData);
    };
    InternationalisationService.prototype.getErrorMessageFromCode = function (c) {
        var sCode = jalhyd_1.ErrorCode[c];
        return this._errorMessages[jalhyd_1.ErrorCode[c]];
    };
    InternationalisationService.prototype.replaceAll = function (str, find, replace) {
        return str.replace(new RegExp(find, 'g'), replace);
    };
    InternationalisationService.prototype.localizeErrorMessage = function (r) {
        var sCode = jalhyd_1.ErrorCode[r.code];
        var m = this.getErrorMessageFromCode(r.code);
        for (var k in r.extraVar) {
            m = this.replaceAll(m, "%" + k + "%", r.extraVar[k]);
        }
        return m;
    };
    return InternationalisationService;
}());
InternationalisationService = __decorate([
    core_1.Injectable(),
    __metadata("design:paramtypes", [http_service_1.HttpService])
], InternationalisationService);
exports.InternationalisationService = InternationalisationService;
//# sourceMappingURL=internationalisation.service.js.map