import { ComputeNodeParameters, IParamsEquation, ParamDefinition, ParamDomainValue, ParamCalculability } from 'jalhyd';

import { NgParameter } from "../ngparam";

export class ParamService {
    // private _params: ParamDefinition[];
    private _params: NgParameter[];

    constructor() {
        // this._params = [new ParamDefinition('Q', ParamDomainValue.POS_NULL),
        // new ParamDefinition('Ks', ParamDomainValue.POS)];
        // for (let p of this._params)
        //     p.calculability = ParamCalculability.DICHO;

        this._params = [];

        // précision de calcul
        let pr = new ParamDefinition('Pr', ParamDomainValue.POS, 0.001);
        this._params.push(new NgParameter(pr));

        this.addParameters("cond_distri");
    }

    private hasParameter(symbol: string): boolean {
        for (let p of this._params) {
            if (p.symbol === symbol)
                return true;
        }
        return false;
    }

    private addParameters(computeNodeName: string) {
        let cdp: IParamsEquation = ComputeNodeParameters.getInstance().getComputeNodeParameters(computeNodeName);
        // console.log(cdp);
        for (let pi in cdp) {
            let p = cdp[pi];
            if (!this.hasParameter(p.symbol))
                this._params.push(p);
        }
    }

    getParameter(s: string): NgParameter {
        for (let p of this._params) {
            if (p.symbol == s)
                return p;
        }

        return undefined;
    }

    updateLocalisation(loc: { [key: string]: string }) {
        for (let ki in loc) {
            let p = this.getParameter(ki);
            if (p != undefined)
                p.label = loc[ki];
        }
    }
}
